#include "parserEmscripten.h"
#include "../main/parsersEtvo.cpp"    // includes all parsers 
using namespace std;
using namespace etvo;

namespace calculatorEtvo
{

  void parseEM(std::string str)
  {
	typedef std::string::const_iterator iterator_type;
    	typedef calculatorEtvo::calculator<iterator_type> calculator;

    	boost::spirit::ascii::space_type space; // Our skipper
	
    	calculator calc; // Our grammar
    	string line=str;
	std::string::const_iterator iter = line.begin();
        std::string::const_iterator end = line.end();
	try{
	 bool r = phrase_parse(iter, end, calc, space);
  	 if (r && iter == end)
				  {
					  /*
					  cout << "stack Ed=" << calculatorEtvo::stack_Ed.size() << endl;
					  cout << "stack MM=" << calculatorEtvo::stack_MM.size() << endl;
					  cout << "stack Tg=" << calculatorEtvo::stack_Tg.size() << endl;
					  cout << "stack mEd=" << calculatorEtvo::stack_mEd.size() << endl;
					  cout << "stack mMM=" << calculatorEtvo::stack_mMM.size() << endl;
					  cout << "stack mTg=" << calculatorEtvo::stack_mTg.size() << endl;
					  cout << "vect Uint=" << calculatorEtvo::vect_Uint.size() << endl;
					  cout << "vect Int=" << calculatorEtvo::vect_Int.size() << endl;
					  */					
				  }
				  else
				  {
					  cout << "syntax error";
					  while (calculatorEtvo::stack_Ed.size()) calculatorEtvo::stack_Ed.pop();
					  while (calculatorEtvo::stack_Tg.size()) calculatorEtvo::stack_Tg.pop();
					  while (calculatorEtvo::stack_MM.size()) calculatorEtvo::stack_MM.pop();
					  while (calculatorEtvo::stack_mEd.size()) calculatorEtvo::stack_mEd.pop();
					  while (calculatorEtvo::stack_mTg.size()) calculatorEtvo::stack_mTg.pop();
					  while (calculatorEtvo::stack_mMM.size()) calculatorEtvo::stack_mMM.pop();
					  calculatorEtvo::vect_Uint.clear();
					  calculatorEtvo::vect_Int.clear();
				  }
	}
 catch (const etvoException & exEtvo)
      {
        cout << exEtvo.Message();
        while (calculatorEtvo::stack_Ed.size()) calculatorEtvo::stack_Ed.pop();
        while (calculatorEtvo::stack_Tg.size()) calculatorEtvo::stack_Tg.pop();
        while (calculatorEtvo::stack_MM.size()) calculatorEtvo::stack_MM.pop();
		while (calculatorEtvo::stack_mEd.size()) calculatorEtvo::stack_mEd.pop();
		while (calculatorEtvo::stack_mTg.size()) calculatorEtvo::stack_mTg.pop();
		while (calculatorEtvo::stack_mMM.size()) calculatorEtvo::stack_mMM.pop();
        calculatorEtvo::vect_Uint.clear();
        calculatorEtvo::vect_Int.clear();
      }
      catch (const exception & ex)
      {
        cout << ex.what();
      }
  }
}

