#pragma once
#include "../main/parsersEtvo.h"
#include <map>

typedef std::map<std::string, etvo::seriesEd> symtab_sed;
typedef std::map<std::string, etvo::seriesTg> symtab_stg;
typedef std::map < std::string, etvo::series> symtab_smm;

typedef std::map<std::string, etvo::matrix<etvo::seriesEd>> symtab_med;
typedef std::map<std::string, etvo::matrix<etvo::seriesTg>> symtab_mtg;
typedef std::map < std::string, etvo::matrix<etvo::series>> symtab_mmm;


namespace calculatorEtvo
{
 extern symtab_sed vars_Ed;  // vars in E[d] définie ailleurs
 extern  symtab_stg vars_Tg;  // vars in T[g]
 extern  symtab_smm vars_MM;  // vars in MinMaxGD
 extern  symtab_med vars_mEd;  // vars in matrix<E[d]>
 extern  symtab_mtg vars_mTg;  // vars in matrix<T[g]>
 extern  symtab_mmm vars_mMM;  // vars in matrix<MinMaxGD>
 void parseEM(std::string str);
}
