#include "gNgdDd.h"
#include<sstream>
#include<cmath>
#include<exception>
using namespace std;

namespace etvo
{
/// set the default form (=0) as Left Form
unsigned gNgdDd::_canon=0;  

void gNgdDd::setCanonForm(unsigned val)
{
	gNg::setCanonForm(val);
	dDd::setCanonForm(val);
}

unsigned gNgdDd::getCanonForm()
{
	return gNg::getCanonForm();
}

gNgdDd::gNgdDd(const gNg & E,const dDd & T):_E(E),_T(T)
{
	canon();
}

gNg gNgdDd::getgNg() const { return _E; }

dDd gNgdDd::getdDd() const { return _T; }

void gNgdDd::canon(){	_E.canon(); _T.canon(); }

void gNgdDd::canonL()
{
	_E.canonL(); _T.canonL();
}

void gNgdDd::canonR()
{
	_E.canonR(); _T.canonR();
}

void gNgdDd::canonC()
{
	_E.canonC(); _T.canonC();
}

std::string gNgdDd::toString(unsigned nVer) const
{
     return _E.toString(nVer) + '.' + _T.toString();
}

 std::ostream & operator<<(std::ostream & f, const gNgdDd & m)
 {
     f<<m.toString();
     return f;
 }
 
} //fin namespace
