#ifndef gNgdDd_H
#define gNgdDd_H
#include<string>
#include<utility>
#include <iostream>

#include "gNg.h"
#include "dDd.h"

/*!
* \file  gNgdDd.h
*
*/

/*! \namespace etvo
* namespace for ETVO classes
*/
namespace etvo
{


/*!
* \class etvo::gNgdDd
* 
* \author BC LH JT LARIS
* \version 2.1
*/

class gNgdDd   
{
    public:
        static void setCanonForm(unsigned val=0);  //0=Left 1=Center 2=Right
		static unsigned getCanonForm();

        gNgdDd(const gNg & E, const dDd & T);
		
        gNg getgNg() const;
		
		dDd getdDd() const;
		
        /// set to the canonical form (depends on setCanonForm choice)
        void canon();
        /// set to the Left form 
        void canonL();
        /// set to the Central 
         void canonC();
        /// set to the Right form 
        void canonR();
        
        /// gives a string description of a gNgdDd term
        /// \param nVer (default=0)   
        ///  
        /// if nVer=0 -> produces string  "g-3.m3.b4.g4"         
        /// if nVer!=0 -> only for development 
        std::string toString(unsigned nVer=0) const;
    protected:
        /// set the canonical form of gNg (default left form)
        static unsigned _canon;
		gNg _E;
		dDd _T;		
};

    /*! operator to print an element into the standard ostream */
    std::ostream & operator<<(std::ostream & f, const gNgdDd & m);
}
#endif // gNgdDd_H
