// mainExample.cpp
// Examples illustrating the ETVO documentation

#include "../etvo.h"
#include "../testsEtvo.h"

using namespace std;
using namespace etvo;

int main()
{	
	seriesTg s1(td(1)*tv(3)*tw(4)*td(-1)*tg(-2));
	cout << s1 << endl;
	cout << seriesTg::toCausal(s1) << endl;
	
	auto s = randGen::Rand_seriesTg_fixedG(3, 4, 5);
	auto p = s.getP();
	auto val = gd(p[0].getG(), p[0].getT_op().getRw().getValue(0));
	auto shift = gd(-val.getg() - 5, -val.getd() - 6);
	s = s * Tg(shift.getd(),shift.getg());
	s.toRight();
	cout << s << endl;
	auto sc = seriesTg::toCausal(s);
	sc.toRight();
	cout << sc << endl;

	/*
	seriesET sa = randGen::Rand_seriesTg(4, 5, 4);
	seriesET sb = randGen::Rand_seriesEd(4, 5, 4);

	auto s = sa * sb;

	s.toCoreEd();
	s.canon();
	cout << "s=" <<s.toString(1) << endl;
	s.toCoreTg();
	s.toCoreEd();
	s.canon();
	cout << "s=" << s.toString(1) << endl;
	s.toCoreTg();
	s.canon();
	cout << "s=" << s.toString(1) << endl;
	*/


	/*
	seriesET s = randGen::Rand_seriesTg_fixedG(4, 5, 4);
	cout << "(1)" << s << endl;
	s.toCoreEd();
	cout << "(2)" << s << endl;
	s.toCoreTg();;
	cout << "(3)" << s << endl;
	s.toCoreEd();
	cout << "(4)" << s << endl;

	cout << s.toString(2) << endl;
	*/

	/*
	matrix<seriesET> A(4, 4), B(4, 1), C(1, 4);
	B(0, 0) = etg(0); 	 // \gamma^0\delta^0=e
	C(0, 1) = etg(0);
	C(0, 3) = etg(1);	// \gamma^1
	A(0, 3) = etg(2);;
	A(1, 0) = etd(2);	// \delta^2
	A(2, 1) = etg(0);
	A(3, 2) = etd(3);

	matrix<seriesET>  H = C * A.star() * B;
	cout << H(0, 0) << endl;
	// output : (g0.d2+g1.d5).[g2.d5]*
	*/
	
	/*
	matrix<seriesET> A(4, 4), B(4, 1), C(1, 4);
	B(0, 0) = eb(2);  // \beta_2
	C(0, 1) = eb(2);
	C(0, 3) = eg(1);  // \gamma^1
	A(0, 3) = eb(3)*eg(5)*em(2);  // \beta_3.\gamma^5.\mu_2
	A(1, 0) = em(3)*ed(2);	//\mu_3.\delta^2
	A(2, 1) = eg(0);	//\gamma^0=e
	A(3, 2) = eb(2)*ed(5);	//\beta_2.\delta^5
	matrix<seriesET>  H = (C * A.star()*B);
	H(0, 0).toRight();
	cout << H(0, 0) << endl;
	// output = ((m3.b4.g2+g1.m3.b4).d2+(g1.m3.b4.g2+g2.m3.b4).d7).[g2.d7]*

	auto P = H.lfrac(H);
	cout << P << endl;

	auto F = P.rfrac(H);
	cout << F << endl;

	auto CL = H * (F*H).star();
	cout << CL << endl;
	
	auto h = H(0, 0);


	cout << h.toString(1) << endl;
	*/
	/*
	try {
		matrix<seriesET> A(4, 4), B(4, 1), C(1, 4);
		B(0, 0) = tD(3);	//\Delta_3
		C(0, 1) = td({ 1,0 });	// \delta^<1,0>	
		C(0, 3) = tg(1);	// \gamma^1
		A(0, 3) = tg(2);
		A(1, 0) = td(1);	//\delta^1		
		A(2, 1) = tg(0);
		A(3, 2) = td({ 2,3,2 });
		

		matrix<seriesET>  H = (C * A.star()*B);
		H(0, 0).toRight();
		cout << H << endl;
		auto h = H(0, 0);
		//cout << H(0, 0).toStringAsDeltaVar() << endl;
		// output =((d<1,4,3,2,3,2>.g0))+(d<4,6,5>.g1+d<5,8,7,6,7,6>.g2).[d3.g2]*
		//cout << H << endl;

		auto p = h.lfrac(h);
		p.toRight();
		cout << p << endl;

		auto f = p.rfrac(h);
		f.toRight();
		cout << f << endl;

		seriesET cl = h * (f*h).star();
		cout << cl << endl;

	}
	catch (const exception & ex)
	{
		cout << ex.what() << endl;
	}
	*/
	
}

