// mainParserEdTg.cpp

// illustrates how to use the specific parsers 

// compilation from etvoVer/

// dependencies : etvo.cpp parsersEtvo.cpp testsEtvo.cpp 
// g++ -std=c++11 -Wno-deprecated -o main/mainParsers.exe main/mainParsersEdTg.cpp etvo.cpp main/parsersEtvo.cpp main/testsEtvo.cpp

#include <iostream>
#include <exception>

#include "../etvo.h"
#include "../test/Test.h"
#include "../parsers/parser.h"
#include "../etvo/common/global.h"
#include "../test/factory/FactoryFper.h"
#include "../test/factory/FactoryPoly.h"
#include "../test/factory/FactorySeries.h"
#include "../test/factory/FactoryPolyEd.h"
#include "../test/factory/FactoryPolyTg.h"
#include "../test/factory/FactorySeriesEd.h"

using namespace std;
using namespace etvo;
using namespace test;

int main()
{ 	
	try {
		
		auto s0 = etvo::parser::parseSeries("[g3.d4+g5.d7]*");
		cout << s0 << endl;

		auto s1 = etvo::parser::parseSeriesEd("[g3.m4.b4.g1.d4+g1.m3.b3.g2.d3]*");

		cout << s1 << endl;

		auto s2 = etvo::parser::parseSeriesTg("[d3.v4.w4.d1.g4+d1.v3.w3.d2.g3]*");
		cout << s2 << endl;


	}
	catch (const exception & ex )
	{
		cout << ex.what() << endl;
	}
	return 0;

}

 
  
  


 
