//
void do_pushGammaET(int n) {  stack_ET.push(etg(n)); }


void do_pushDeltaET(int t) { stack_ET.push(etd(t)); }

void do_pushEpsET() { stack_ET.push(seriesET::Epsilon()); }

void do_pushMuET(int m) { stack_ET.push(etm(m)); }
void do_pushBetaET(int b) { stack_ET.push(etb(b)); }
void do_pushVeeET(int v) { stack_ET.push(etv(v)); }
void do_pushWedgeET(int w) { stack_ET.push(etw(w)); }

void do_pushMuVarET()
{
	//E_op muv = E_op::MuVar(vect_Uint);	
	seriesET p(etm(vect_Uint));
	vect_Uint.clear();
	stack_ET.push(p);
}
void do_pushBetaVarET()
{	
	seriesET p(etb(vect_Uint));
	vect_Uint.clear();
	stack_ET.push(p);
}

void do_pushDeltaVarET()
{
	//T_op deltav = T_op::deltaVar(vect_Int);
	seriesET p(etd(vect_Int));
	vect_Int.clear();
	stack_ET.push(p);
}

void do_infET() {
	seriesET last = stack_ET.top();
	stack_ET.pop();
	seriesET first = stack_ET.top();
	stack_ET.pop();
	seriesET res = first.inf(last);
	stack_ET.push(res);
}

void do_lfracET() {
	seriesET last = stack_ET.top();
	stack_ET.pop();
	seriesET first = stack_ET.top();
	stack_ET.pop();
	seriesET res = first.lfrac(last);
	stack_ET.push(res);
}

void do_rfracET() {
	seriesET last = stack_ET.top();
	stack_ET.pop();
	seriesET first = stack_ET.top();
	stack_ET.pop();
	seriesET res = first.rfrac(last);
	stack_ET.push(res);
}


void do_prcausET() {
	seriesET last = stack_ET.top();
	stack_ET.pop();
	seriesET res = seriesET::toCausal(last);	
	stack_ET.push(res);
}

void do_rightET() {
	seriesET last = stack_ET.top();
	stack_ET.pop();
	last.toRight();
	stack_ET.push(last);
}

void do_leftET() {
	seriesET last = stack_ET.top();
	stack_ET.pop();
	last.toLeft();
	stack_ET.push(last);
}


void do_pushVarET()
{
	string strET = "s" + strIdent;
	strIdent.clear();
	//cout << strET << endl;

	symtab_set::iterator it = vars_ET.find(strET);
	if (it == vars_ET.end())
	{
		string str = "undefined name " + strET;
		cerr << str << endl;
		stack_ET.push(seriesET::Epsilon());
	}
	else
	{
		stack_ET.push(vars_ET[strET]);
	}
}

void do_equalET()
{
	seriesET last = stack_ET.top();
	stack_ET.pop();
	seriesET first = stack_ET.top();
	stack_ET.pop();
	//if (first == last) cout << "true";
	//else cout << "false";
	cout << "not implemented yet";
}
void do_pushIdentET()
{
	//std::cout << "pushEd" << endl;
	//std::cout << "se_"+strIdentEd << endl;
	stack_identET.push("s" + strIdent);
	strIdent.clear();
}

void do_printVarET()
{
	string strET = "s" + strIdent;
	strIdent.clear();

	symtab_set::iterator it = vars_ET.find(strET);
	if (it == vars_ET.end())
	{
		string str = "undefined name " + strET;
		cerr << str << endl;
	}
	else
	{
		cout << strET <<"="<< vars_ET[strET];
	}
}

void do_kleeneET()
{
	seriesET last = stack_ET.top();
	stack_ET.pop();
	last = last.star();
	stack_ET.push(last);
}


void do_otimesET() {
	seriesET last = stack_ET.top();
	stack_ET.pop();
	seriesET first = stack_ET.top();
	stack_ET.pop();
	seriesET res = first * last;
	stack_ET.push(res);
}

void do_oplusET() {
	seriesET last = stack_ET.top();
	stack_ET.pop();
	seriesET first = stack_ET.top();
	stack_ET.pop();
	seriesET res = first + last;
	stack_ET.push(res);
}

void do_assignET()
{
	string ident = stack_identET.top();
	stack_identET.pop();
	seriesET last = stack_ET.top();
	vars_ET[ident] = last;
	stack_ET.pop();
	cout << ident << "=" << last;
}


void do_printET()
{
	if (stack_ET.size() > 0)
	{
		std::cout << stack_ET.top() << endl;
		stack_ET.pop();
	}
}

void do_asRightET()
{
	seriesET last = stack_ET.top();
	stack_ET.pop();
	cout << last.toString(1);
}

void do_asLeftET()
{
	seriesET last = stack_ET.top();
	stack_ET.pop();
	cout << last.toString(2);
}

void do_toCoreEdET()
{
	seriesET last = stack_ET.top();
	stack_ET.pop();
	last.toCoreEd();
	last.canon();
	stack_ET.push(last);
}

void do_toCoreTgET()
{
	seriesET last = stack_ET.top();
	stack_ET.pop();
	last.toCoreTg();
	last.canon();
	stack_ET.push(last);
}

void do_asMuVarRET()
{
	seriesET last = stack_ET.top();
	stack_ET.pop();
	last.toCoreEd();
	last.canon();
	cout << last.toString(3);
}

void do_asMuVarLET()
{	
	seriesET last = stack_ET.top();
	stack_ET.pop();
	last.toCoreEd();
	last.canon();
	cout << last.toString(4);
}

void do_asDeltaVarRET()
{
	seriesET last = stack_ET.top();
	stack_ET.pop();
	last.toCoreTg();
	last.canon();
	cout << last.toString(3);
}

void do_asDeltaVarLET()
{
	seriesET last = stack_ET.top();
	stack_ET.pop();
	last.toCoreTg();
	last.canon();
	cout << last.toString(3);
}

///////////////////////////////////////////////////




