#include <iostream>
#include <exception>
#include "../Test.h"
//#include "../../parsers/parser.h"

using namespace std;
using namespace etvo;

namespace test
{
  bool Test::TestCanonSeriesTg(unsigned nIter)
  {
    cout << "TestCanonSeriesTg " << endl;
    unsigned j;
    bool success=true;
	j = 0;
	
	while (j < nIter && success)
	{
		unsigned dp = randGen::uni_int(1, 8);
		unsigned codp = randGen::uni_int(1, 8);
		int g = randGen::uni_int(2, 10);
		int d = randGen::uni_int(2, 10);

		Tg off = randGen::Rand_Tg_fixedG(dp, dp, 6, 6);
		polyTg p = randGen::Rand_polyTg_fixedG(dp, codp, 6);
		polyTg q = randGen::Rand_polyTg_fixedG(dp, codp, 6);
		q = q * off;
		seriesTg s1(p, q, g, d);
		if (!s1.isProper())
		{
			cout << "Unproper seriesTg";
			success = false;
			cout << "p=" << p << endl;
			cout << "q=" << q << endl;
			cout << "r=" << gd(g, d) << endl;
		}
		j++;
		cout << "->";
	}
	
	j = 0;
	while (j < nIter && success)
	{
		unsigned dp = randGen::uni_int(1, 10);
		unsigned codp = randGen::uni_int(1, 10);
		int g = randGen::uni_int(2, 8);
		int d = randGen::uni_int(2, 8);

		Tg off = randGen::Rand_Tg_fixedG(dp, dp, 8, 8);
		polyTg p = randGen::Rand_polyTg_fixedG(dp, codp, 10);
		polyTg q = randGen::Rand_polyTg_fixedG(dp, codp, 10);
		q = q * off;
		seriesTg s1(p, q, g, d);
		int timeWindow = randGen::uni_int(20, 50);
		polyTg trans1 = seriesTg::getPolyUpTo(timeWindow, p, q, gd(g, d));
		polyTg trans2 = s1.getPolyUpTo(timeWindow);
		if (!(trans1 == trans2))
		{
			polyTg trans3 = seriesTg::getPolyUpTo(timeWindow, s1.getP(), s1.getQ(), s1.getR());
			cout << "Problem in the development of a seriesTg" << endl;
			cout << "p=" << p << endl;
			cout << "q=" << q << endl;
			cout << "r=" << gd(g, d) << endl;
			cout << "s1=" << s1 << endl;
			cout << "trans1 -> " << timeWindow << "=" << trans1 << endl;
			cout << "trans2 -> " << timeWindow << "=" << trans2 << endl;
			polyTg trans4 = seriesTg::getPolyUpTo(timeWindow + 10, p, q, gd(g, d));
			cout << "trans4 = " << trans4 << endl;
			seriesTg::getPolyUpTo(timeWindow + 10, p, q, gd(g, d));
			success = false;
		}
		cout << "->";
		j++;
	}
	
    j = 0;
    while (j < nIter && success)
    {
      j++;     
      int g = randGen::uni_int(2, 8);
      int d = randGen::uni_int(2, 8);
      poly p = randGen::Rand_poly(8);
      poly q = randGen::Rand_poly(8);
      gd off = gd(randGen::uni_int(10,20), randGen::uni_int(10, 20));
      series s(p, q, gd(g,d)); 
      polyTg pp = polyTg::toPolyTg(p);
      polyTg qq = polyTg::toPolyTg(q);
      seriesTg s1(pp, qq, g, d, true);
      seriesTg s2(pp, qq, g, d, false);
	        
      if (!(seriesTg::toSeriesTg(s) == s1))
      {
        cout << "Problem A" << endl;
        cout << "seriesTg::ToSeriesTg(s) != s1" << endl;
        cout << "s1=" << s1 << endl;
        cout << "seriesTg::ToSeriesTg(s)=" << seriesTg::toSeriesTg(s) << endl;
        success = false;
      }

      if(!(seriesTg::toSeriesTg(s) == s2))
      {
        cout << "Problem B" << endl;
        cout << "seriesTg::ToSeriesTg(s) != s2" << endl;
        cout << "s2=" << s1 << endl;
        cout << "seriesTg::ToSeriesTg(s)=" << seriesTg::toSeriesTg(s) << endl;
        success = false;
      }
    }
	

    // Test de dcomposition (impulse response) / Recomposition
    j = 0;
    while (j < nIter && success)
    {      
      unsigned dp = randGen::uni_int(2, 6);
      unsigned codp = randGen::uni_int(2, 6);
      int g = randGen::uni_int(2, 5);
      int d = randGen::uni_int(2, 5);

      Tg off = randGen::Rand_Tg_fixedG(dp, dp, 6, 6);
      polyTg p = randGen::Rand_polyTg_fixedG(dp, codp, 8);
      polyTg q = randGen::Rand_polyTg_fixedG(dp, codp, 8);
      q = q * off;	  
      seriesTg s1(p, q, g, d,false);  //left form
	  // decomposition as Impulse response	 
      vector<series> decomp;
      decomp = s1.toImpulseResponse();      	
      dDd f(0, s1.getMaxGain().first,s1.getMaxGain().second,-s1.getMaxGain().second+1);
      Tg fTg(T_op(f), 0);
      seriesTg factor(fTg);	 
      seriesTg resultat;
      while (decomp.size())
      {        
		resultat = resultat + (seriesTg::toSeriesTg(decomp[0])*factor);
        factor = factor * seriesTg(Tg::d(-1));
		decomp.erase(decomp.begin());
      }      
      if (!(s1 == resultat))
      {
        cout << "Problem C" << endl;
        cout << "s1=" << endl << s1 << endl;
        cout << "resultat=" << endl << resultat;
        success = false;
      }
      j++;
      cout << "->";
    }
		    
    j = 0;
    while (j < nIter && success)
    {
      unsigned dp = randGen::uni_int(1, 8);
      unsigned codp = randGen::uni_int(1, 8);
      int g = randGen::uni_int(2, 8);
      int d = randGen::uni_int(2, 8);

      Tg off = randGen::Rand_Tg_fixedG(dp, dp, 6, 6);
      polyTg p = randGen::Rand_polyTg_fixedG(dp, codp, 8);
      polyTg q = randGen::Rand_polyTg_fixedG(dp, codp, 8);
      q = q * off;
      seriesTg s1(p, q, g, d, true);  //right form
      seriesTg s2(p, q, g, d, false); //left form
      
      if (!s1.isProper())  cout << endl << "s1=" << s1 << endl;      
      if(!s2.isProper())   cout << "s2=" << s2 << endl;
      
      seriesTg copieS1(s1);
      seriesTg copieS2(s2);
      s1.toLeft();
      s1.toRight();
      s2.toRight();
      s2.toLeft();

      if (!(s1 == copieS1))
      {
        cout << "Problem in Left<-> Right conversion" << endl;
        success = false;
      }
      if (!(s2 == copieS2))
      {
        cout << "Problem in Left<-> Right conversion" << endl;
        success = false;
      }



      int timeWindow = randGen::uni_int(10,30);
      polyTg trans1a = seriesTg::getPolyUpTo(timeWindow, p, q, gd(g, d), true);
      polyTg trans1b = s1.getPolyUpTo(timeWindow);

      polyTg trans2a = seriesTg::getPolyUpTo(timeWindow, p, q, gd(g, d), false);
      polyTg trans2b = s2.getPolyUpTo(timeWindow);

      if (!(trans1a == trans1b))
      {
        cout << "Problem in the development of a seriesTg" << endl;
        cout << "p=" << p << endl;
        cout << "q=" << q << endl;
        cout << "r=" << gd(g, d) << endl;
        cout << "s1=" << s1 << endl;
        cout << "trans1a -> " << timeWindow << "=" << trans1a << endl;
        cout << "trans1b -> " << timeWindow << "=" << trans1b << endl;
        success = false;
      }

      if (!(trans2a == trans2b))
      {
        cout << "Problem in the development of a seriesTg" << endl;
        cout << "p=" << p << endl;
        cout << "q=" << q << endl;
        cout << "r=" << gd(g, d) << endl;
        cout << "s2=" << s2 << endl;
        cout << "trans2a -> " << timeWindow << "=" << trans2a << endl;
        cout << "trans2b -> " << timeWindow << "=" << trans2b << endl;
        success = false;
      }
      j++;
      cout << "->";
    }

	
    j = 0;
    while (j < nIter && success)
    {
      j++;
      unsigned dp = randGen::uni_int(1, 8);
      unsigned codp = randGen::uni_int(1, 8);
      int g = randGen::uni_int(2, 8);
      int d = randGen::uni_int(2, 8);

      Tg off = randGen::Rand_Tg_fixedG(dp, dp, 6, 6);
      polyTg p = randGen::Rand_polyTg_fixedG(dp, codp, 8);
      polyTg q = randGen::Rand_polyTg_fixedG(dp, codp, 8);
      q = q * off;
      seriesTg s1(p, q, g, d, true);  //right form
      seriesTg s2(p, q, g, d, false); //left form

      for (unsigned k = 0; k < 5; k++)
      {
        int timeWindow = randGen::uni_int(5, 30);
        polyTg trans1a = seriesTg::getPolyUpTo(timeWindow, p, q, gd(g, d), true);
        polyTg trans1b = s1.getPolyUpTo(timeWindow);

        polyTg trans2a = seriesTg::getPolyUpTo(timeWindow, p, q, gd(g, d), false);
        polyTg trans2b = s2.getPolyUpTo(timeWindow);

        if (!(trans1a == trans1b))
        {
          cout << "Problem in the development of a seriesEd" << endl;
          cout << "p=" << p << endl;
          cout << "q=" << q << endl;
          cout << "r=" << gd(g, d) << endl;
          cout << "s1=" << s1 << endl;
          cout << "trans1a -> " << timeWindow << "=" << trans1a << endl;
          cout << "trans1b -> " << timeWindow << "=" << trans1b << endl;
          success = false;
          break;
        }

        if (!(trans2a == trans2b))
        {
          cout << "Problem in the development of a seriesEd" << endl;
          cout << "p=" << p << endl;
          cout << "q=" << q << endl;
          cout << "r=" << gd(g, d) << endl;
          cout << "s2=" << s2 << endl;
          cout << "trans2a -> " << timeWindow << "=" << trans2a << endl;
          cout << "trans2b -> " << timeWindow << "=" << trans2b << endl;
          success = false;
          break;
        }
      }

    }
    if (!success)
    {
      cout << endl << "Test failed !" << endl;
    }
    else cout << endl << "Test successful" << endl;
	
	return success;
  }
}