#include <iostream>
#include <exception>
#include "../Test.h"
//#include "../../parsers/parser.h"

using namespace std;
using namespace etvo;

namespace test
{
  bool Test::TestCoreSeriesTg(unsigned nIter)
  {
    cout << endl << endl << "Test Core SeriesTg" << endl;
    unsigned j = 0;
    bool success = true;
    while (j < nIter && success)
    {
      unsigned dp = randGen::uni_int(2, 6);
      unsigned codp = randGen::uni_int(2, 6);
      int g = randGen::uni_int(2, 6);
      int d = randGen::uni_int(2, 6);

      Tg off = randGen::Rand_Tg_fixedG(dp, dp, 3, 3);
      polyTg p = randGen::Rand_polyTg_fixedG(dp, codp, 5);
      polyTg q = randGen::Rand_polyTg_fixedG(dp, codp, 5);
      q = q * off;
      dDd::setCanonForm(1);
      
      seriesTg s1(p, q, g, d, false);  //left form
      matrix<series> C1 = s1.getCore();         
      seriesTg s2 = seriesTg::coreToSeriesTg(C1);    
	 // dDd::setCanonForm(1);
	  //cout << C1 << endl;
	  //cout << s1 << endl;
      //cout << s2 << endl;
      //cout << "(" << C1.GetRow() << "x" << C1.GetColumn() << ")";
      if (!(s1 == s2))
      {
        cout << "Problem !" << endl;
        cout << "s1=" << s1 << endl;
        cout << "s2=" << s2 << endl;
        success = false;
      }

      // series gain 1,1
      series ss = randGen::Rand_series(5, gd(1, 3));
      seriesTg s3 = seriesTg::toSeriesTg(ss);
      matrix<series> C2 = s3.getCore();     
      seriesTg s4 = seriesTg::coreToSeriesTg(C2);
      if (!(s3 == s4))
      {
        cout << "Problem !" << endl;
        cout << "s3=" << s3 << endl;
        cout << "s4=" << s4 << endl;
        success = false;
      }

      poly ps = randGen::Rand_poly(8);
      seriesTg s5 = seriesTg(polyTg::toPolyTg(ps));
      matrix<series> C3 = s5.getCore();   
      seriesTg s6 = seriesTg::coreToSeriesTg(C3);

      if (!(s5 == s6))
      {
        cout << "Problem !" << endl;
        cout << "s5=" << s5 << endl;
        cout << "s6=" << s6 << endl;
        success = false;
      }    
     
      j++;
      cout << "->";
    }

    if (success == false)
    {
      cout << endl <<"Test failed!" << endl;
    }
    else cout <<endl << "Test successful" << endl;
	return success;
  }
}