#include "FactoryPolyTg.h"
#include "randGen.h"
namespace etvo
{
  FactoryPolyTg::FactoryPolyTg(unsigned int nbTerms, unsigned int M,
	  unsigned int B, int gap, bool fixedGain,
    bool fixedOff, const etvo::gd & off, int range,int percentEps)
  {
    _M = M;
	_B = B;
    _nbTerms = nbTerms;
    _fixedGain = fixedGain;
    _fixedOffset = fixedOff;
    _offset = off;
    _range = range;
    _gap = gap;
	_percentEps = std::min(std::max(percentEps, 0), 50);
  }
     
  etvo::polyTg FactoryPolyTg::create() const
  {
	  int rand1_100 = randGen::uni_int(0, 100);
	  if (rand1_100 <= _percentEps) return polyTg::Epsilon();
    unsigned int appliedM = _M;
	unsigned int appliedB = _B;

    gd appliedOffset = _offset;
    if (!_fixedGain)
    {
      appliedM = randGen::uni_int(1, _M);      
	  appliedB = randGen::uni_int(1, _B);
    }
    if (!_fixedOffset)
    {
      int g = _offset.getg() + randGen::uni_int(-_range, _range);
      int d = _offset.getd() + randGen::uni_int(-_range, _range);
      appliedOffset = gd(g, d);
    }
    
    //return randGen::Rand_polyTg_fixedG(appliedMB,_nbTerms,_gap);
    return randGen::Rand_polyTg_fixedG(appliedOffset, appliedM,appliedB,_nbTerms, _gap);
  }
}